#include "FindTheme.h"
#include <stdlib.h>
#include <unistd.h>

#define QTMESSPATH \
   "./:" \
   "~/.qtmess/themes/:" \
   "/usr/local/share/qtmess/themes/:" \
   "/usr/share/qtmess/themes/" \

QString
FindTheme(QString theme_name) {
   QString homepat("~/");
   QString dirpat("/");
   QString home = getenv("HOME");
   if (! home.endsWith(dirpat)) {
      home.append(dirpat);
   }
   const char * theme_path = getenv("QTMESSPATH");
   if (theme_path == NULL) {
      theme_path = QTMESSPATH;
   }
   QString path(theme_path);
   while (! path.isNull()) {
      QString next_path;
      int cp = path.indexOf(':');
      if (cp != -1) {
         next_path = path.right((path.length() - cp) - 1);
         path = path.left(cp);
      }
      if (path.startsWith(homepat)) {
         path.replace(0, homepat.length(), home);
      }
      if (! path.endsWith(dirpat)) {
         path.append(dirpat);
      }
      path.append(theme_name);
      path.append(dirpat);
      QString xmlfile = path;
      xmlfile.append("qtmess.xml");
      const char * cxml = xmlfile.toAscii().constData();
      if (access(cxml, R_OK) == 0) {
         break;
      }
      path = next_path;
   }
   return path;
}
