#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <unistd.h>
#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>

/* Silly helper program for invoking qtmess via the -k option of the remind
 * program: Remind invokes me with a single argument, I split that argument
 * into multiple arguments a bit like the shell (but I only look for space
 * and quotes, no fancy escaping or anything like that).
 *
 * I then invoke qtmess with the new set of multiple arguments that creates.
 *
 * If the 1st arg is -b, then fork before execing qtmess (run in background).
 */

int
main(int argc, char ** argv) {

   int background = 0;
   if ((argc > 2) && (strcmp(argv[1], "-b") == 0)) {
      background = 1;
      --argc;
      ++argv;
   }
   if (argc == 2) {
      char * s = argv[1];
      char * d = s;
      int len = strlen(s);
      char ** nargv = calloc(len + 2, sizeof(char *)); /* overkill argv size */
      int nargs = 0;
      int state = 1;

      nargv[nargs++] = "qtmess";
      while (state > 0) {
         char c = *s++;
         switch(state) {
         case 1:        /* skipping space */
            if (isspace(c)) {
               state = 1;
            } else if (c == '\0') {
               state = 0;
            } else if (c == '\'') {
               nargv[nargs++] = d;
               state = 3;
            } else if (c == '\"') {
               nargv[nargs++] = d;
               state = 4;
            } else {
               nargv[nargs++] = d;
               *d++ = c;
               state = 2;
            }
            break;
         case 2:        /* gathering non-space */
            if (isspace(c) || (c == '\0')) {
               *d++ = '\0';
               if (c == '\0') {
                  state = 0;
               } else {
                  state = 1;
               }
            } else if (c == '\'') {
               state = 3;
            } else if (c == '\"') {
               state = 4;
            } else {
               *d++ = c;
               state = 2;
            }
            break;
         case 3:        /* inside single quote */
            if (c == '\'') {
               if (isspace(*s)) {
                  *d++ = '\0';
                  state = 1;
               } else {
                  state = 2;
               }
            } else if (c == '\0') {
               state = 0;
            } else {
               *d++ = c;
               state = 3;
            }
            break;
         case 4:        /* inside double quote */
            if (c == '\"') {
               if (isspace(*s)) {
                  *d++ = '\0';
                  state = 1;
               } else {
                  state = 2;
               }
            } else if (c == '\0') {
               state = 0;
            } else {
               *d++ = c;
               state = 4;
            }
            break;
         }
      }
      nargv[nargs] = (char *)0;
      if (background) {
         if (fork() != 0) {
            exit(0);
         }
      }
      execvp(nargv[0], nargv);
   }
   return 2;
}
